public void superDraw(Sport SPL, SportLeague GEN, SportLeague PRO, SportLeague TEAM, int[][] NYT2, int[] NYT1) {
  
  fill(myColors[0]);
  if(visSPL1) paintYearsByMonthHighCounts(SPL.name, GEN.yearly, layout+gutter);
  fill(myColors[1]);
  if(visSPL2) paintYearsByMonth(SPL.name, PRO.yearly, layout+gutter);
  
  if(SPL.name == ss[0]) fill(200,0,0);
  else if(SPL.name == ss[1]) fill(0,200,0);
  else if(SPL.name == ss[2]) fill(0,0,200);
  if(visSPL3) paintYearsByMonth(SPL.name, TEAM.yearly, layout+gutter);
  fill(myColors[3]);
  if(visNYTm) paintYearsByMonth(SPL.name, NYT1, layout+gutter);
  
  fill(myColors[4]);
  if(visNYTy) {
    for(int i=0; i<years.length; i++) {
      for(int j=0; j<12; j++) {
        NYT_month(NYT2[i][j], (layout)+gutter+(i*column)+(j*block) );
       }
    }
  }
  
}


public void paintHeader(String s) {
  fill(BLACK);
  textFont(fontLarge);
  textAlign(CENTER, TOP);
  text("Professional Sports", column*2+20, gutter);
  textFont(fontM);
  textAlign(CENTER, CENTER);
  int x = column-10;
  int y = column+gutter-block;
  if(visBaseball) {
    textFont(fontM); fill(200,0,0);
    text("Seattle\n"+ tms[0], x, y);
    textFont(fontItalic); fill(BLACK_AA);
    text(tms[1] +"\nPress 2", x+column+20, y);
    text(tms[2] +"\nPress 3", x+column*2+40, y);
  } else if(visBasketball) {
    textFont(fontItalic); fill(BLACK_AA);
    text(tms[0] +"\nPress 1", x, y);
    textFont(fontM); fill(0,200,0);
    text("Seattle\n"+ tms[1], x+column+20, y);
    textFont(fontItalic); fill(BLACK_AA);
    text(tms[2] +"\nPress 3", x+column*2+40, y);
  } else if(visFootball) {
    textFont(fontItalic); fill(BLACK_AA);
    text(tms[0] +"\nPress 1", x, y);
    text(tms[1] +"\nPress 2", x+column+20, y);
    textFont(fontM); fill(0,0,200);
    text("Seattle\n"+ tms[2], x+column*2+40, y); fill(BLACK);
  }
}

public void paintKey() {
  textFont(fontItalicSmall);
  textAlign(CENTER, BOTTOM);
  fill(WHITE);
  int x=gutter+gutter;
  int y=height; 
  int y2=height-gutter-1;
  int inc = x;
  
  fill(BLACK_AA); text("'a'", x, y2);
  if(visSPL1) fill(myColors[0]);
  else        fill(WHITE);
  text("SPL\nSport",x,y);
  
  fill(BLACK_AA); text("'s'", x+inc, y2);
  if(visSPL2) fill(myColors[1]); 
  else        fill(WHITE);
  text("SPL\nLeague",x+inc,y);

  fill(BLACK_AA); text("'d'", x+inc*2, y2);
  if(visSPL3) fill(myColors[2]); 
  else        fill(WHITE);
  text("SPL\nTeam",x+inc*2,y);

  fill(BLACK_AA); text("'f'", x+inc*3, y2);
  if(visNYTm) fill(myColors[3]); 
  else        fill(WHITE);
  text("NYT\nYears",x+inc*3,y);

  fill(BLACK_AA); text("'g'", x+inc*4, y2);
  if(visNYTy) fill(myColors[4]); 
  else        fill(WHITE);
  text("NYT\nMonths",x+inc*4, y);
}

public void paintToplist2(Reading[] r, int x0, int y0) {
  textFont(fontSerif);
  textAlign(LEFT, TOP);
  fill(BLACK_AA); 
  int x = x0; int y = y0;
  int inc = 0;
  for(int a=0; a< r.length; a++) {
    if(r[a] != null) {
      text(r[a].title, x, y);
      if(r[a].subject != null) text(r[a].subject, x, y+25);
      if(r[a].mediaType != null) text(r[a].mediaType, x+25, y+25);

      for(int z=0;z<years.length;z++) { 
       if(r[a].yearly[z] !=0) text(r[a].yearly[z], x+inc, y+40);
       else text("x", x+inc, y);
       inc += (gutter+block);
      }
      y+=55;
    } //end if
    inc =0;
  }
}

public void paintToplist(Reading[] r, int x0, int y0) {
 textFont(fontSerif);
 textAlign(LEFT, BOTTOM);
 fill(BLACK_AA);
 int x = x0;
 int y = y0;
 int inc = 0;
 for(int a=r.length-1;a>0;a--) {
   if(r[a] != null) { 
     for(int z=0;z<years.length;z++) { 
       if(r[a].yearly[z] !=0) text(r[a].yearly[z], x+inc, y);
       else text("x", x+inc, y);
       inc += (gutter+block);;
     }
     text("~~  "+ r[a].couts, x+inc, y);
     text(r[a].title, x, y-18);
     y -= 40;
   }
   inc=0;
 } 
 
  
}

public void paintBottomTick(int start) {
  textFont(fontItalic);
  textAlign(CENTER, CENTER);
  fill(WHITE);
  int x= start;
  int y= height-(gutter/2);
  for(int p=0;p<years.length;p++) {
    text(years[p], x, y);
    x+=column; 
  }
}

public void highlightYear(int yr) {
  fill(BLACK_A);
  rect(layout+gutter+(column*yr), 0, column, height);
}

public void paintCurrToplist() {
  Reading[] buf = new Reading[8];
  for(int a=0;a<6;a++) buf[a] = popularityInstance[activeSport][focusYear][a];
  paintToplist(buf, gutter, height-(column*3)-gutter);
}
/*
public void paintCurrNYT(Micro[] r) {
 textFont(fontSerif);
 textAlign(RIGHT, TOP);
 fill(BLACK_AA);
 int x = width-gutter;
 int y = gutter;
 int inc = 0;
 
 for(int a=0; a<r.length; a++) {
   if(r[a] != null) {text(r[a].keyword, x, y+inc);
   inc += 15;}
 }
  
}*/

public void paintYearsByMonthHighCounts(String sport, int[] a, int start) {
  textFont(fontItalic);
  textAlign(CENTER, BOTTOM);
  int val, tmp=0;
  int x = start;
  for(int yr=0; yr<a.length; yr++) {
      val = a[yr];
      //println(sport);
      if(sport == "Baseball") {
        /*if( val >= height )*/ tmp = (val*400)/maxBase;
        //else tmp = val;
      } else if(sport == "Basketball") {
        /*if(val>=height)*/ tmp = (val*400)/maxBasket;
        //else tmp = val;
      } else if(sport == "Football") {
        /*if(val>=height) */tmp = (val*400)/maxFoot;
        //else tmp = val;
      }
      
     ellipse(x+(column/2), height - tmp -gutter*2, column+block, block);

      
      //rect(x, height - tmp - gutter-block, column, block);
      text(val, x+(column/2), height - tmp - gutter*2-4);
       //textAlign(CENTER, BOTTOM);

      x+=column;
    } 
}

public void paintYearsByMonth(String sport, int [] a, int start) {
  textFont(fontItalic);
  textAlign(CENTER, BOTTOM);
  int val, tmp=0;
  int x = start;
  for(int yr=0; yr<a.length; yr++) {
      val = a[yr];
      //println(sport);
      if(sport == "Baseball") {
        /*if( val >= height )*/ tmp = (val*750)/maxBase;
        //else tmp = val;
      } else if(sport == "Basketball") {
        /*if(val>=height)*/ tmp = (val*750)/maxBasket;
        //else tmp = val;
      } else if(sport == "Football") {
        /*if(val>=height) */tmp = (val*750)/maxFoot;
        //else tmp = val;
      }
      
     ellipse(x+(column/2), height - tmp -gutter*2, column+block, block);

      
      //rect(x, height - tmp - gutter-block, column, block);
      text(val, x+(column/2), height - tmp - gutter*2-4);
       //textAlign(CENTER, BOTTOM);

      x+=column;
    } 
}

public void NYT_month(int m, int start) {
   // rect(start, height - (m*1.5) - gutter-block, block, block);
   ellipse(start+(block/2), height - (m*1.5) - gutter-block, block, block);
}



void draw() {
  background(WHITE);
  fill(BLACK);
  smooth();
  //noStroke();
  rect(0,height-gutter,width,gutter);
  
  
  paintKey();
  paintHeader("useless");
  
  textFont(fontS);
  textAlign(LEFT, BOTTOM);
  fill(darkcyan);
  text("Popular items in "+ years[focusYear], gutter, column*2+gutter+block);
  text("Alltime popular items", gutter, column*5-gutter);
  fill(BLACK);
  
  for(int p=0;p<8;p++) {
    if( (mouseX >= layout+gutter+(column*p)) && (mouseX < layout+gutter+(column*(p+1)))) {
     focusYear = p; 
     highlightYear(focusYear);
     //println(years[p]);
    }
  }
  
  paintCurrToplist();
  
  
  if(visBaseball) {
    superDraw(generalBaseball, baseball, mlb, mariners, dataMariners, yearlyMariners);
    paintToplist(topBaseball, gutter, height-gutter-gutter);
      //paintCurrNYT(topBaseb);

  } else if(visBasketball) {
    superDraw(generalBasketball, basketball, nba, supersonics, dataSupersonics, yearlySonics);
    paintToplist(topBasketball, gutter, height-gutter-gutter);
     // paintCurrNYT(topBasketb);


  } else if(visFootball) {
    superDraw(generalFootball, football, nfl, seahawks, dataSeahawks, yearlySeahawks);
    paintToplist(topFootball, gutter, height-gutter-gutter);
      //paintCurrNYT(topFootb);
    
  }
  
 
        paintBottomTick(layout+gutter+(column/2));

}
  
  /*String [] top6 = new String[6];
  int a=5;
  for( String key : generalBaseball.keySet() ) {
    int couts = generalBaseball.get(key).couts; 
    if(couts > generalBaseball.get(top5[5]).couts) {
      while(couts > generalBaseball.get(top6[a]).couts) {
        a--;
      } 
      
    }
    
  }
  */
   
  /*
  
  for(int acc=0; acc<years.length;acc++) {
        fill(myColors[acc]);

  for(String key : football.proteam.keySet() ) {
    int couts = football.proteam.get(key).coutByYear[acc];
    String [] trash;
    trash = key.split(" ");
    //text( trash[0], x, couts*5);
    text( couts, x+20, couts*5);
    x+=8;
    y+=0;
    max = couts;         
  }
  x=90; y=100;
  
}
  */
         

